'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MatchMediaListener = function (_Component) {
  (0, _inherits3.default)(MatchMediaListener, _Component);

  function MatchMediaListener() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MatchMediaListener);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MatchMediaListener.__proto__ || (0, _getPrototypeOf2.default)(MatchMediaListener)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      matches: false,
      mediaQueryList: null
    }, _this.listener = function (e) {
      _this.setState({ matches: e.matches });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MatchMediaListener, [{
    key: 'componentDidMount',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var listener, mediaQueryList;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                listener = this.listener;

                if (!(typeof window !== 'undefined')) {
                  _context.next = 6;
                  break;
                }

                _context.next = 4;
                return this.setState({
                  matches: window.matchMedia(this.props.matchQueryString).matches,
                  mediaQueryList: window.matchMedia(this.props.matchQueryString)
                });

              case 4:
                mediaQueryList = this.state.mediaQueryList;

                mediaQueryList.addListener(listener);

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _ref2.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var listener = this.listener,
          mediaQueryList = this.state.mediaQueryList;

      mediaQueryList.removeListener(listener);
    }
  }, {
    key: 'render',
    value: function render() {
      var matches = this.state.matches,
          children = this.props.children;

      return children({ matches: matches });
    }
  }]);
  return MatchMediaListener;
}(_react.Component);

MatchMediaListener.propTypes = {
  matchQueryString: _propTypes2.default.string.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children']));

exports.default = enhance(MatchMediaListener);