'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ViewportScanner = function (_React$Component) {
  (0, _inherits3.default)(ViewportScanner, _React$Component);

  function ViewportScanner() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ViewportScanner);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ViewportScanner.__proto__ || (0, _getPrototypeOf2.default)(ViewportScanner)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      bottomIsVisible: true
    }, _this.handleScroll = function () {
      var _this2 = _this,
          bottomIsVisible = _this2.state.bottomIsVisible,
          _this2$props = _this2.props,
          containerSelector = _this2$props.containerSelector,
          isLocked = _this2$props.isLocked,
          onViewportStatusChange = _this2$props.onViewportStatusChange;

      var containerElement = document.querySelector(containerSelector);
      if (!isLocked) {
        if (containerElement.getBoundingClientRect().bottom > 0) {
          if (bottomIsVisible === false) {
            onViewportStatusChange({ bottomIsVisible: bottomIsVisible });
          }
          _this.setState({ bottomIsVisible: true });
        } else {
          if (bottomIsVisible === true) {
            onViewportStatusChange({ bottomIsVisible: bottomIsVisible });
          }
          _this.setState({ bottomIsVisible: false });
        }
      }
    }, _this.componentDidMount = function () {
      var _this3 = _this,
          handleScroll = _this3.handleScroll;

      handleScroll();
      typeof window !== 'undefined' && window.addEventListener('scroll', handleScroll);
    }, _this.componentWillUnmount = function () {
      var _this4 = _this,
          handleScroll = _this4.handleScroll;

      window.removeEventListener('scroll', handleScroll);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ViewportScanner, [{
    key: 'render',
    value: function render() {
      var bottomIsVisible = this.state.bottomIsVisible,
          children = this.props.children;

      return children({ bottomIsVisible: bottomIsVisible });
    }
  }]);
  return ViewportScanner;
}(_react2.default.Component);

ViewportScanner.defaultProps = {
  isLocked: false,
  onViewportStatusChange: function onViewportStatusChange() {
    return null;
  }
};


ViewportScanner.propTypes = {
  isLocked: _propTypes2.default.bool,
  onViewportStatusChange: _propTypes2.default.func,
  containerSelector: _propTypes2.default.string.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['isLocked', 'children']));

exports.default = enhance(ViewportScanner);