'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MountUnmount = (0, _recompose.compose)((0, _recompose.withState)('mounted', 'setMounted', true))(function (_ref) {
  var children = _ref.children,
      mounted = _ref.mounted,
      setMounted = _ref.setMounted;
  return _react2.default.createElement(
    'div',
    { style: { display: 'flex', flexDirection: 'column', margin: '5rem' } },
    _react2.default.createElement(
      _Button2.default,
      { onClick: function onClick() {
          return setMounted(!mounted);
        } },
      mounted ? 'mounted' : 'unmounted'
    ),
    mounted && children
  );
});

var enhance = (0, _recompose.compose)();

exports.default = enhance(MountUnmount);